using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;

namespace dqwsExampleCSharpSingleRecord
{
	/// <summary>
	/// Melissa Data Single Address Check
	/// </summary>
	/// <remarks>
	/// 
	/// http://localhost/mdWebService/Address.asmx
	/// 
	///Intructions
	///=============================================================
	///1) Add a Web Reference:
	///Production server:
	///http://ws.melissadata.com/dqws/Address.asmx
	///2) Name it: dqws
	/// </remarks>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnClear;
		protected System.Web.UI.WebControls.Label Label12;
		protected System.Web.UI.WebControls.CheckBox ChkpkgTelephoneGeographicArea;
		protected System.Web.UI.WebControls.CheckBox ChkpkgTelephoneNumber;
		protected System.Web.UI.WebControls.CheckBox ChkpkgZipCodeZipInCity;
		protected System.Web.UI.WebControls.CheckBox ChkpkgZipCodeInformation;
		protected System.Web.UI.WebControls.CheckBox ChkpkgZipCodeCitiesInState;
		protected System.Web.UI.WebControls.CheckBox ChkpkgStreetDataOnAddressErrorsOnly;
		protected System.Web.UI.WebControls.CheckBox ChkpkgStreetDataInRangeRecordsOnly;
		protected System.Web.UI.WebControls.CheckBox ChkpkgStreetDataAllRecords;
		protected System.Web.UI.WebControls.CheckBox ChkpkgNameParsed;
		protected System.Web.UI.WebControls.CheckBox ChkpkgAddressGeoCode;
		protected System.Web.UI.WebControls.CheckBox ChkpkgAddressGeographicArea;
		protected System.Web.UI.WebControls.CheckBox ChkpkgAddressParsed;
		protected System.Web.UI.WebControls.CheckBox ChkpkgAddressMailing;
		protected System.Web.UI.WebControls.Button btnSingleAddressCheck;
		protected System.Web.UI.WebControls.Label Label4;
		protected System.Web.UI.WebControls.TextBox txtCustomerID;
		protected System.Web.UI.WebControls.Label Label5;
		protected System.Web.UI.WebControls.TextBox txtCity;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.TextBox txtState;
		protected System.Web.UI.WebControls.Label Label6;
		protected System.Web.UI.WebControls.Label Label7;
		protected System.Web.UI.WebControls.TextBox txtZip5;
		protected System.Web.UI.WebControls.TextBox txtCountry;
		protected System.Web.UI.WebControls.Label Label8;
		protected System.Web.UI.WebControls.Label Label9;
		protected System.Web.UI.WebControls.TextBox txtPhoneNum;
		protected System.Web.UI.WebControls.TextBox txtResults;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.TextBox txtParsedRequest;
		protected System.Web.UI.WebControls.Label Label10;
		protected System.Web.UI.WebControls.Label Label13;
		protected System.Web.UI.WebControls.TextBox txtFullName;
		protected System.Web.UI.WebControls.TextBox txtPlus4;
		protected System.Web.UI.WebControls.Label Label11;
		protected System.Web.UI.WebControls.TextBox txtUrbanization;
		protected System.Web.UI.WebControls.CheckBox ChkpkgAddressDeliveryPointValidation;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.TextBox txtAddress;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSingleAddressCheck.Click += new System.EventHandler(this.btnSingleAddressCheck_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnSingleAddressCheck_Click(object sender, System.EventArgs e)
		{
			//initialize variables
			//temporary string
			string tStr1;
			//a reference string to be passed with the request and 
			//received back with the response
			string _transmission_reference;

			_transmission_reference = "Address Check test#1";

			//temporary variables
			int i1, tCount;

			//3) Initialize it:
			//==================================================
			//create action object	
			mdws.mdWebServices Action = 
				new mdws.mdWebServices();
			//request
			mdws.RequestRecord Request = 
				new mdws.RequestRecord();
			//response
			mdws.ResponseRecord Response = 
				new mdws.ResponseRecord();

			//4) enter the CustomerID here
			Request.CustomerID = txtCustomerID.Text;

			//5)Choose a package. For example:
			//Request.pkgAddressMailing = true;

			if (ChkpkgAddressMailing.Checked)
			{
				Request.pkgAddressMailing = true;
			}

			if (ChkpkgAddressParsed.Checked)
			{
				Request.pkgAddressParsed = true;
			}

			if (ChkpkgAddressGeographicArea.Checked)
			{
				Request.pkgAddressGeographicArea = true;
			}

			if (ChkpkgNameParsed.Checked)
			{
				Request.pkgNameParsed = true;
			}

			if (ChkpkgTelephoneNumber.Checked) 
			{
				Request.pkgTelephoneNumber = true;
			}

			if (ChkpkgTelephoneGeographicArea.Checked)
			{ 
				Request.pkgTelephoneGeographicArea = true;
			}
			
			//subscription
			if (ChkpkgAddressDeliveryPointValidation.Checked) 
			{
				Request.pkgDeliveryIndicator = true;
			}

			//subscription
			if (ChkpkgAddressGeoCode.Checked) 
			{
				Request.pkgAddressGeoCode = true;
			}


			//subscription
			if (ChkpkgStreetDataAllRecords.Checked)
			{
				Request.pkgStreetDataAllRecords = true;
			}

			if (ChkpkgStreetDataInRangeRecordsOnly.Checked) 
			{
				Request.pkgStreetDataInRangeRecordsOnly = true;
			}

			if (ChkpkgStreetDataOnAddressErrorsOnly.Checked)
			{
				Request.pkgStreetDataOnAddressErrorsOnly = true;
			}

			//subscription
			if (ChkpkgZipCodeCitiesInState.Checked) 
			{
				Request.pkgZipCodeCitiesInState = true;
			}

			if (ChkpkgZipCodeInformation.Checked) 
			{
				Request.pkgZipCodeInformation = true;
			}

			if (ChkpkgZipCodeZipInCity.Checked) 
			{ 
				Request.pkgZipCodeZipInCity = true;
			}

			Request.transmissionReference = _transmission_reference;

			//6) Initalize address variables.

			Request.CustomerID = txtCustomerID.Text;
			Request.Address = txtAddress.Text;
			Request.City = txtCity.Text;
			Request.State = txtState.Text;
			Request.Zip5 = txtZip5.Text;
			Request.Plus4 =txtPlus4.Text;
			Request.Country = txtCountry.Text;

			Request.FullName = txtFullName.Text;
			Request.Telephone = txtPhoneNum.Text;

			//7) call the web service
			//=============================================================

			//Note: make a loop structure in order to prevent
			//loss of data in case of bad connection to dqws.
            short Retry;
            bool ReqRet;

            Retry = 0;
            ReqRet = false;
            do {
				try 
				{
					Response = (mdws.ResponseRecord)Action.doSingleRecord(Request);
					ReqRet = true;
				}
				catch (Exception ReqEx)
				{					 
					Retry++;
				}
			} while ((ReqRet==false) && (Retry < 5));

			
			tStr1="";
			//get response parameters
			//=============================================================

			//BEGIN check response
			if (Response != null) 
			{
				//BEGIN check if there are a Service Faults
				if (Response.ServiceFaults != null) 
				{
					// count the Service Faults
					tCount=Convert.ToInt16(Response.ServiceFaults.count); 
					if (tCount > 0) 
					{
						// if there are service faults, show the first one
						tStr1 += "ServiceFaults.Fault(0).Code=" + Response.ServiceFaults.Fault[0].Code + "\r\n";
						tStr1 += "ServiceFaults.Fault(0).Desc=" + Response.ServiceFaults.Fault[0].Desc + "\r\n";
						tStr1 += "ServiceFaults.Fault(0).Detail=" + Response.ServiceFaults.Fault[0].Detail + "\r\n";
						tStr1 += "ServiceFaults.Fault(0).Source=" + Response.ServiceFaults.Fault[0].Source + "\r\n";
					}
				} //END check if there are a Service Faults

				// check if there are a Service Results
				if (Response.ServiceResult != null) 
				{
					// if there are a Service Results show them
					if (Response.ServiceResult.ErrorCode != null) 
					{
						tStr1 += "ServiceResult.ErrorCode=" + Response.ServiceResult.ErrorCode + "\r\n";
					}
					if (Response.ServiceResult.ErrorDesc !=null) 
					{
						tStr1 += "ServiceResult.ErrorDesc=" + Response.ServiceResult.ErrorDesc + "\r\n";
					}
					if (Response.ServiceResult.StatusCode !=null) 
					{
						tStr1 += "ServiceResult.StatusCode=" + Response.ServiceResult.StatusCode + "\r\n";
					}
					if (Response.ServiceResult.StatusDesc !=null) 
					{
						tStr1 += "ServiceResult.StatusDesc=" + Response.ServiceResult.StatusDesc + "\r\n";
					}
				} //END check response


				//BEGIN AddressResult
				if (Response.Address != null)
				{
					//BEGIN Response.Address.Result
					if (Response.Address.Result !=null)
					{
						// show the errors and status
						tStr1 += "AddressResult.ErrorCode=" + Response.Address.Result.ErrorCode + "\r\n"; 
						tStr1 += "AddressResult.ErrorDesc=" + Response.Address.Result.ErrorDesc + "\r\n";
						tStr1 += "AddressResult.StatusCode=" + Response.Address.Result.StatusCode + "\r\n";
						tStr1 += "AddressResult.StatusDesc=" + Response.Address.Result.StatusDesc + "\r\n";

						tCount=Convert.ToInt16(Response.Address.Faults.count); 
						//BEGIN check AddressFaults
						if (tCount == 0)
						{
							//no PhysicalAddressFaults
							//check if object exist
							if (Response.Address.Urbanization !=null) 
							{
								tStr1 += "Address.Urbanization.UrbanizationCode=" + Response.Address.Urbanization.Code + "\r\n";
							}

							if (Response.Address.Street != null) 
							{
								tStr1 += "Address.Street.Address=" + Response.Address.Street + "\r\n"; 
								txtAddress.Text = Response.Address.Street;
							}

							if (Response.Address.City != null) 
							{
								tStr1 += "Address.City.CityName=" + Response.Address.City.Name + "\r\n";
								tStr1 += "Address.City.CityAbbreviation=" + Response.Address.City.Abbreviation + "\r\n";
								txtCity.Text = Response.Address.City.Name;
							}

							if (Response.Address.State != null) 
							{
								tStr1 += "Address.State.StateAbbreviation=" + Response.Address.State.Abbreviation + "\r\n";
								txtState.Text = Response.Address.State.Abbreviation;
							}

							if (Response.Address.Zip !=null) 
							{
								tStr1 += "Address.Zip.Zip5=" + Response.Address.Zip.Zip5 + "\r\n";
								tStr1 += "Address.Zip.Plus4=" + Response.Address.Zip.Plus4 + "\r\n";
								txtZip5.Text = Response.Address.Zip.Zip5 + "\r\n";
								txtPlus4.Text = Response.Address.Zip.Plus4 + "\r\n";
							}

							if (Response.Address.County != null) 
							{
								tStr1 += "Address.County.CountyName=" + Response.Address.County.Name + "\r\n";
							}

							if (Response.Name != null) 
							{
								tStr1 += "Response.Name.Full=" + Response.Name.Full + "\r\n";
								tStr1 += "Response.Name.First=" + Response.Name.First + "\r\n";
								tStr1 += "Response.Name.Last=" + Response.Name.Last + "\r\n";
								tStr1 += "Response.Name.Gender=" + Response.Name.Gender + "\r\n";
							}

							if (Response.Telephone != null) 
							{
								//tStr1 += "Response.Telephone.City.Abbreviation=" + Response.Telephone.City. + "\r\n";
								tStr1 += "Response.Telephone.City.Name=" + Response.Telephone.City.Name + "\r\n";
								tStr1 += "Response.Telephone.Country.Abbreviation=" + Response.Telephone.Country.Abbreviation + "\r\n";
								tStr1 += "Response.Telephone.Country.Name=" + Response.Telephone.Country.Name + "\r\n";
								tStr1 += "Response.Telephone.County.Fips=" + Response.Telephone.County.Fips + "\r\n";
								tStr1 += "Response.Telephone.County.Name=" + Response.Telephone.County.Name + "\r\n";
								tStr1 += "Response.Telephone.Extension=" + Response.Telephone.Extension + "\r\n";
								tStr1 += "Response.Telephone.GeoCode.Latitude=" + Response.Telephone.GeoCode.Latitude + "\r\n";
								tStr1 += "Response.Telephone.GeoCode.Longitude=" + Response.Telephone.GeoCode.Longitude + "\r\n";
								tStr1 += "Response.Telephone.Msa.Code=" + Response.Telephone.Msa.Code + "\r\n";
								tStr1 += "Response.Telephone.Pmsa.Code=" + Response.Telephone.Pmsa.Code + "\r\n";
								tStr1 += "Response.Telephone.NewAreaCode=" + Response.Telephone.NewAreaCode + "\r\n";
								tStr1 += "Response.Telephone.Number=" + Response.Telephone.Number + "\r\n";
								tStr1 += "Response.Telephone.PhoneAreaCode=" + Response.Telephone.PhoneAreaCode + "\r\n";
								tStr1 += "Response.Telephone.Prefix=" + Response.Telephone.Prefix + "\r\n";
								tStr1 += "Response.Telephone.Suffix=" + Response.Telephone.Suffix + "\r\n";
								tStr1 += "Response.Telephone.State.Abbreviation=" + Response.Telephone.State.Abbreviation + "\r\n";
								//tStr1 += "Response.Telephone.State.Fips=" + Response.Telephone.State.Fips + "\r\n";
								tStr1 += "Response.Telephone.State.Name=" + Response.Telephone.State.Name + "\r\n";
								tStr1 += "Response.Telephone.TimeZone.Code=" + Response.Telephone.TimeZone.Code + "\r\n";
								tStr1 += "Response.Telephone.TimeZone.Name=" + Response.Telephone.TimeZone.Name + "\r\n";
							}


							//DeliveryPointValidation
							if (Response.Address.DPV != null) 
							{
								tStr1 += "Response.Address.DPV.AddressStatus=" + Response.Address.DPV.AddressStatus + "\r\n";
								tStr1 += "Response.Address.DPV.CMRA=" + Response.Address.DPV.CMRA + "\r\n";
								tStr1 += "Response.Address.DPV.Footnotes=" + Response.Address.DPV.Footnotes + "\r\n";
							}

							//GeoCode
							if (Response.Address.GeoCode != null) 
							{
								tStr1 += "Response.Address.GeoCode.Latitude=" + Response.Address.GeoCode.Latitude + "\r\n";
								tStr1 += "Response.Address.GeoCode.Longitude=" + Response.Address.GeoCode.Longitude + "\r\n";
							}

						}
						else 
						{
							//show AddressFaults
							tStr1 += "Address.AddressFaults.count=" + Response.Address.Faults.count + "\r\n";
							tCount=Convert.ToInt16(Response.Address.Faults.count); 
							for (i1 = 0 ; i1 <= (tCount - 1); i1++)
							{
								tStr1 += "AddressFaults.Fault" + Response.Address.Faults.Fault[i1].Code + "\r\n";
								tStr1 += "AddressFaults.Fault" + Response.Address.Faults.Fault[i1].Desc  + "\r\n";
								tStr1 += "AddressFaults.Fault(" + Response.Address.Faults.Fault[i1].Detail + "\r\n";
								tStr1 += "AddressFaults.Fault(" + Response.Address.Faults.Fault[i1].Source + "\r\n";
							}//END for
						} //END check AddressFaults
					}//END Response.Address.Result
				}
				//END AddressResult

				//Street Data
				if (Response.StreetData != null) 
				{
					tStr1 += "Response.StreetData.count=" + Response.StreetData.count + "\r\n";
				}
				
				//ZipCode Data
				if (Response.ZipCodeData != null) 
				{
					tStr1 += "Response.ZipCodeData.count=" + Response.ZipCodeData.count + "\r\n";
				}

			}
			txtResults.Text= tStr1;		
		}
	}
}
	